/* Typography */
@import url(typography.css);




:root {
    /* Color Pallet */
    --clr-1: #595959;
    --clr0: #8a8a8a;
    --clr1: #e3e3e3;
    --clr2: #ffffff;

    --clr-primary: #F2D5D5;
    --clr-mark: #b19c9c;
    --clr-secondary: #1B1026;

    /* BP */
    --xl: 1000px;
    --l: 800px;
    --m: 700px;
    --s: 600px;
}

* {
    box-sizing: border-box;
}





/* BASICS  */
html {
    color: var(--clr2);
    font-family: rubik-black, sans-serif;
}

body {
    margin: 0;
    background: linear-gradient(45deg, rgba(0,255,239,1) 0%, rgba(255,255,255,1) 0%, #b8a2a2 34%, rgba(255,255,255,1) 100%);
    overflow-x: hidden;
}

a {
    color: var(--clr6);
    text-decoration: auto;
}

h1,
h2,
h3,
h4,
h5,
h6,
p {
    margin: 0;
    font-weight: normal;
    margin-inline: 0;
    margin-block: 0;
}

.social-links li > * {
    color: var(--clr2);
}

.text-input {
    flex-grow: 1;
    background-color: var(--clr2);
    height: 2rem;
    border: 0.5px solid var(--clr-secondary);
    border-radius: 4px;
}

.btn {
    height: 2rem;
    background-color: transparent;
    height: 2rem;
    border: 0;
}

.btn:hover,
button:hover {
    cursor: pointer;
    filter: brightness(90%);
    background-color: var(--clr-primary);
}







/* LAYOUT */
.main-layout>*:not(.full) {
    margin-left: auto;
    margin-right: auto;
    max-width: var(--xl);
}

.header-layout {
    display: flex;
    align-items: center;
    justify-content: center;
    height: 100%;
}

.canvas-editor-layout {
    background-color: gray;
    height: 400px;
    margin-block-end: 100px;
}



/* Helpers */
/* List-Helper */
.clean-list {
    padding: 0;
    list-style-type: none;
    margin-block: 0;
    margin-inline: 0;
    padding-inline: 0;
}

/* Btn-helper */
.clean-btn {
    padding: 0;
    border: 0;
    background-color: transparent;
}

/* Text Input Helper */
.clean-text-input {
    border-width: 0;
    border: none;

}

/* Color Picker Helper */
.clean-color-input {
    appearance: none;
    width: 0;
    height: 0;
    color: transparent;
    cursor: pointer;
    padding: 0cm;
    border: 0;
    background-color: transparent;
    display: table-column-group;
}



/* Components */
/* Main Container */
.main-container {
    margin-block-end: 100px;
}

.main-container .line {
    background-color: var(--clr-secondary);
    height: 1px;
    width: 95%;
    margin: auto;
    margin-block-start: 10px;
}

/* Header */
.main-header {
    margin-block-end: 100px;
    background-color: var(--clr2);
}

.main-header .lang-select {
    background-color: transparent;
    color: var(--clr-secondary);
    position: absolute;
    border: 0;
}

.main-header .lang-select option {
    color: var(--clr-2);
}

.main-header .header-logo {
    font-family: Fasthand-Regular;
    font-size: 4em;
    width: 100%;
    color: var(--clr-secondary);
}

.main-header .header-logo:hover {
    cursor: pointer;
}

.main-header .header-logo .logo-dot {
    color: var(--clr-mark);
    font-size: 4rem;
}

.main-header nav ul {
    display: flex;
}

.main-header nav ul>li a {
    transition: 0.1s;
}

.main-header nav ul>li a {
    display: inline-block;

    font-family: rubik-black;
    font-size: 2.1875rem;
    padding-inline: 0.342em;
    padding-block: 1.285em;
    color: var(--clr-secondary);
}

.main-header nav ul>li:last-child a {
    color: var(--clr-secondary);
}

.main-header nav ul>li a:hover {
    box-shadow: inset 0px -4px 0px var(--clr-secondary);
    cursor: pointer;
}

.main-header nav ul>li a.selected {
    color: var(--clr-mark);
    box-shadow: inset 0px -4px 0px var(--clr-secondary);
    cursor: pointer;
}

.main-header nav ul>li a.selected:hover {
    color: var(--clr-secondary);
}

.main-header .dropdown-action {
    display: none;
}


/* Canvas Editor Container */
.canvas-editor-container {
    transition: 0.6s;
    border-radius: 4px;
    display: flex;
    justify-content: space-between;
}

.canvas-editor-container.hide {
    display: none;
}

.canvas-editor-container .canvas-container {
    width: 500px;
    height: 500px;
}

.canvas-editor-container .canvas-container.smaller-canvas {
    width: 350px;
    height: 350px;
}


/* Canvas Editor */
.canvas-editor-container .editor-container {
    padding: 2rem;
    flex-grow: 1;
    position: relative;
}

.canvas-editor-container .editor-container img {
    width: 2rem;
    height: 100%;
}


/* Search Bar */
.search-bar {
    display: grid;
    grid-template-columns: 2fr 6fr 2fr;
    align-content: center;
}

.search-bar input {
    color: var(--clr-secondary);
    font-family: 'rubik-black';
    font-size: 1rem;
    height: 100%;
    border: 0;
    border-radius: 25px;
    min-width: 200px;
    text-indent: 20px;
}

.search-bar input:focus {
    outline: none;
}

.search-bar input::placeholder {
    padding-inline-start: 5px;
}

.search-bar .random-meme-action {
    font-size: 1.1875rem;
    font-family: 'rubik-black';
    color: var(--clr-secondary);
    padding: 10px;
    background-color: var(--clr2);
    border-radius: 25px;
}

.search-bar .random-meme-action:hover {
    color: var(--clr-mark);
    filter: brightness(100%);
    cursor: pointer;
}

.search-bar .keywords {
    display: flex;
    justify-content: space-evenly;
    align-items: center;
}

.search-bar .keywords button {
    background-color: var(--clr-secondary);
}

.search-bar span {
    color: var(--clr-secondary);
    font-family: 'rubik-black';
}

.search-bar span:hover {
    cursor: pointer;
    color: var(--clr-mark);   
}

.search-bar span:hover {
    cursor: pointer;
}



/* Gallery */
.gallery-container,
.saved-memes-container {
    transition: 0.6s;
}

.gallery-container .gallery,
.saved-memes-container .saved-memes {
    display: grid;
    display: grid;
    grid-template-columns: repeat(auto-fit, minmax(100px, 280px));
    gap: 10px;
    padding: 60px;
}

.gallery-container .gallery img,
.saved-memes-container .saved-memes img {
    border-radius: 6px;
    width: 100%;
    transition: 0.6s all;
    max-width: 300px;
    filter: blur(1px);
    transform: translate(0, 0)
}

.gallery-container .gallery img:hover,
.saved-memes-container .saved-memes img:hover {
    filter: blur(0px);
    cursor: pointer;
    box-shadow: black 0 1px 5px 0px;
}

.gallery-container.hide {
    display: none;
}

/* Flash Msg */
.user-msg {
    position: fixed;
    bottom: -100px;
    right:10px;
    background-color: #111;
    padding: 10px;
}

.user-msg.open {
    bottom: 10px;
    transition: bottom .5s;
}

/* Saved Memes Gallery */
.saved-memes {
    display: flex;
}

.saved-memes-container.hide {
    display: none;
}


/* Canvas Editor Actions */
.text-input-actions {
    background-color: var(--clr2);
    border-radius: 2em;
    margin-block-end: 50px;
}

.text-input-actions input {
    border: 0;
    background-color: transparent;
}

.text-input-actions label {
    display: flex;
}

.text-input-actions label > * {
    border: 0;
    background-color: transparent;
}


/* Text Actions */
.text-style-actions {
    display: flex;
    justify-content: center;
    background-color: var(--clr2);
    border-radius: 2em;
    margin-block-end: 50px;
}

.text-style-actions > *:not(:last-child) {
    margin-inline: 5px;
}

.text-style-actions.margin {
    margin-block-end: 50px;
    height: 32px;
}

.text-style-actions .font-picker-action {
    flex-grow: 1;
}

.text-style-actions .font-picker-action select {
    width: 100%;
    height: 100%;
}

.text-align-actions {
    display: flex;
    justify-content: center;
    margin-block-end: 30px;
    background-color: var(--clr2);
    border-radius: 2em;
    margin-block-end: 50px;
}

.text-align-actions > * {
    margin-inline: 5px;
}

.text-align-actions .movement-actions {
    display: flex;
}

.delete {
    flex-grow: 1;
}




.save-share-update-actions {
    display: flex;
    justify-content: center;
    display: flex;
    justify-content: center;
    margin-block-end: 30px;
    background-color: var(--clr2);
    border-radius: 2em;
    margin-block-end: 50px;
}

.save-share-update-actions > *:first-child {
    margin-inline: 5px;
}

.save-share-update-actions .add-file-action {
    width: 100%;
    height: 32px;
}

.save-share-update-actions .add-file-action::file-selector-button {
    border:0px;
    color: var(--clr-secondary);
    background-color: transparent;
    font-size: 1.2rem;
}

.download-modal-actions button {
    background-color: var(--clr2);
    border-radius: 2em;
}

.open-download-modal-action {
    font-size: 3rem;
    position: absolute;
    bottom: 0;
    right: 0;
    width: 90%;
    margin-inline-start: 5%;
    margin-inline-end: 5%;
    padding: 20px;
    border: 0;
    background-color: transparent;
    transition: 0.6s;
    border-radius: 2em;
}

.open-download-modal-action:hover {
    cursor: pointer;
    background-color: transparent;
    outline: 0.5px solid var(--clr-secondary);
}

.editor-container .demo {
    display: none;
}


/* Footer */
.footer-layout {
    padding-block-start: 2rem;
    background-color: var(--clr2);
    border-block-start: 5px solid var(--clr-secondary-strong);
}

.footer-layout .about-me-container {
    display: flex;
    justify-content: space-evenly;
    align-items: center;
}

.footer-layout .about-me {
    display: flex;
    justify-content: center;
    padding-block-end: 2rem;
}

.footer-layout .personal-img {
    border-radius: 50%;
    width: 300px;
    margin-inline-end: 2rem;
    margin-inline-start: 2rem;
    border: 5px solid var(--clr-primary);
}

.footer-layout .personal-text {
    display: flex;
    flex-direction: column;
    justify-content: center;
    color: var(--clr-secondary);
    margin-inline-end: 2rem;
}

.footer-layout .social-links {
    margin-block-start: 2rem;
    display: flex;
}

.footer-layout .social-links li {
    padding: 1rem;
    border-radius: 20px;
    background-color: var(--clr-secondary);
    margin-inline-end: 1rem;
    min-width: 50px;
    min-height: 50px;
    display: flex;
    justify-content: center;
    align-content: center;
}

.footer-layout .legal-rights {
    background-color: var(--clr-secondary);
    padding-block: 2rem;
    text-align: center;
    color: var(--clr2);
}
.download-share-modal {
    background-color: var(--clr1);
    opacity: 0.8;
    position: fixed;
    left: 0;
    bottom: 0;
    width: 100%;
    height: 100vh;
}


/* Modal */
.download-modal {
    opacity: 0;
    transition: 0.6s;
    display: none;
}

body.open-modal .download-modal {
    position: fixed;
    width: 100%;
    height: 100vh;
    background-color: var(--clr0);
    opacity: 0.9;
    top: 0;
    left: 0;
    transition: 0.6s;
    display: block;

}

body.open-modal .download-modal .modal-container {
    border: 5px solid var(--clr-secondary);
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    background-color: var(--clr-1);
    width: 50%;
    height: 25%;

    display: flex;
    justify-content: space-around;
    flex-direction: column;
    align-items: center;

}

.download-modal:hover {
    cursor: pointer;
}



@media screen and (max-width: 1100px) {
    .main-layout>*:not(.full) {
        max-width: var(--l);
    }

    .gallery-container .gallery,
    .saved-memes-container .saved-memes {
        grid-template-columns: repeat(auto-fit, minmax(150px, 1fr));
    }

    .main-header .header-logo {
        font-size: 3em;
    }


    .canvas-editor-container .editor-container {
        padding: 1rem;
    }
}


@media screen and (max-width: 950px) {
    .main-layout>*:not(.full) {
        max-width: var(--m);
    }

}

@media screen and (max-width: 720px) {
    .main-layout>*:not(.full) {
        max-width: var(--s);
    }

    .main-header .header-logo {
        font-size: 3em;
    }

    .gallery-container,
    .saved-memes-container {
        border: 0ch;
    }
    .search-bar .keywords {
        display: none;
    }
    .search-bar {
        grid-template-columns: 1fr 1fr;
    }
    .search-bar input {
        width: 100%;
    }
    .btn:hover, button:hover {
        background-color: transparent;
    }

}

@media screen and (max-width: 720px) {

    .main-layout>*:not(.full) {
        max-width: initial;
    }

    .main-header {
        margin-block-end: 50px;
        position: fixed;
        top: 0;
        left: 0;
        width: 100%;
        z-index: 1;
    }

    .canvas-editor-container {
        border: none;
        display: flex;
        flex-direction: column;
        align-items: center;
    }

    .canvas-editor-container .canvas-container {
        width: 100%;
    }

    .dropdown {
        z-index: 10;
        position: fixed;
        width: 100%;
        top: 116px;
        background-color: var(--clr-primary);
        display: flex;
        flex-direction: column;
        transform: translate(0, -100%);
        opacity: 0;
        text-align: center;
        left: 0%;
        transition: 0.6s;
    }

    .dropdown.open {
        transform: translate(0, 0);
        opacity: 1;
    }

    .dropdown a {
        width: 100%;
    }

    .main-header .header-logo {
        font-size: 5em;
    }

    .main-header nav ul>li a {
        display: inline-block;
        font-family: rubik-black;
        font-size: 0;
        padding-inline: 0.342em;
        border-inline-start: 0.05em solid var(--clr0);
        padding-block: 0;
        transition: 0.1s;
    }

    .main-header nav ul>li a.open {
        font-size: 2.1875rem;
        padding-block: 1.285em;
        color: var(--clr-2);
    }

    .main-header .dropdown-action {
        display: inline;
        margin-inline-end: 30px;
    }

    .main-header .dropdown-action i {
        /* width: 50px; */
        height: 50px;
        width: 100%;
        height: 100%;
        font-size: xxx-large;
        color: var(--clr-primary);
    }

    .footer-layout .personal-img {
        width: 100px;
        height: 100px;
    }

    .main-header .header-logo {
        font-size: 3em;
    }

    .main-container {
        margin-block-start: 121px;
    }

    .open-download-modal-action {
        bottom: -85px;
        border-radius: 50px;
    }

    .gallery-container .gallery,
    .saved-memes-container .saved-memes {
        min-height: auto;
    }

    .editor-container .text-input-actions .picker {
        display: none;
    }

}

@media screen and (max-width: 450px) {
    .footer-layout .personal-img {
        width: 50px;
        height: 50px;
    }

    .main-header .header-logo {
        font-size: 2em;
        margin-inline-start: 30px;
    }

    .gallery-container .search-bar {
        display: flex;
    }

    .search-bar label {
        flex-basis: 50%;
    }

    .footer-layout .personal-text {
        margin-inline-end: 0rem;
    }
}